#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>

int b;
//struct Matrix{int mat[2][2];};

typedef struct matrix{
	int mat[2][2];
}Matrix;


Matrix matmult(Matrix A, Matrix B){
	Matrix ans;
	int i,j,k;

	for(i=0;i<2;i++)
		for(j=0;j<2;j++){
			for(ans.mat[i][j]=k=0;k<2;k++) ans.mat[i][j]+=((A.mat[i][k]*B.mat[k][j])%b);
			ans.mat[i][j]=ans.mat[i][j]%b;			
		}
	return ans;
}


Matrix matPow(Matrix base, long long p){
	Matrix ans;
	int i,j;

	for(i=0;i<2;i++) for(j=0;j<2;j++) ans.mat[i][j] = (i==j);
	while(p){
		if(p%2==1) ans = matmult(ans,base);
		base=matmult(base,base);
		p=p/2;
	}
	return ans;
}


/*

int** mult(int **A, int **B){
	int i,j,k;
	static int mat[2][2];

//	mat=(int**)malloc(2*sizeof(int*));
//	for(i=0;i<2;i++) mat[i]=(int*)malloc(2*sizeof(int));
	
	for(i=0;i<2;i++)
		for(j=0;j<2;j++){
			mat[i][j]=0;
			for(k=0;k<2;k++) mat[i][j]+=((A[i][k]*B[k][j])%b);
		}
	return (int**)mat;
}

int** expo(int **A,long long int n){
	static int res[2][2];
	int i;	
	
//	res=(int**)malloc(2*sizeof(int*));
//	for(i=0;i<2;i++) res[i]=(int*)malloc(2*sizeof(int));

	if(n==0) {res[0][0]=1;res[0][1]=0;res[1][0]=0;res[1][1]=1; return res;}
	else{
		res=expo(A,n/2);
		res=mult(res,res);
		if(n%2==1) res=mult(res,A);
		return 	res;
	}
		
}


*/

int main(){
	long long n;
	int cont=0;	
	Matrix A;
	Matrix M;

	scanf("%Ld %d",&n,&b);
	while(n!=0 || b!=0){
		A.mat[0][0]=1;A.mat[0][1]=1;A.mat[1][0]=1;A.mat[1][1]=0;		
		cont++;
		M = matPow(A,n-1);
		printf("Case %d: %Ld %d %d\n",cont,(long long int)n,b,(2*(M.mat[0][0]+M.mat[0][1])-1)%b);
		scanf("%Ld %d",&n,&b);
	}
return 0;
}

