#include<stdio.h>
#include<stdlib.h>

#define b 1000000

typedef long long ll;
typedef struct matrix{
	ll mat[2][2];
}Matrix;


Matrix matmult(Matrix A, Matrix B){
	Matrix ans;
	int i,j,k;

	for(i=0;i<2;i++)
		for(j=0;j<2;j++){
			for(ans.mat[i][j]=k=0;k<2;k++) ans.mat[i][j]+=((A.mat[i][k]*B.mat[k][j])%b);
			ans.mat[i][j]=ans.mat[i][j]%b;			
		}
	return ans;
}


Matrix matPow(Matrix base, ll p){
	Matrix ans;
	int i,j;

	for(i=0;i<2;i++) for(j=0;j<2;j++) ans.mat[i][j] = (i==j);
	while(p){
		if(p%2==1) ans = matmult(ans,base);
		base=matmult(base,base);
		p=p/2;
	}
	return ans;
}


int main(){
	ll N,K,L;
	Matrix M;
	Matrix A;
	
	while(scanf("%Ld %Ld %Ld",&N,&K,&L)){
		N/=5;
		A.mat[0][0]=K;A.mat[0][1]=L;A.mat[1][0]=1;A.mat[1][1]=0;
		M=matPow(A,N-1);
		printf("%06Ld\n",(K*(M.mat[0][0])+(M.mat[0][1]))%b);
	}
return 0;
}
